/*
Eteria IRC Client, an RFC 1459 compliant client program written in Java.
Copyright (C) 2000  Javier Kohen <jkohen at tough.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package ar.com.jkohen.awt;

import java.awt.Graphics;
import java.lang.reflect.*;

public class NewGraphics2D
{
	private static Method setRenderingHint;
	private static Object keyAA, valueAA, keyRender, valueRender;
	
	public static boolean hasRenderingHints = false;
	
	public NewGraphics2D()
	{
	}
	
	public static void setRendering(Graphics g)
	{
		if (setRenderingHint != null)
		{
			try
			{
				/*
				** Graphics2D g2d = (Graphics2D)g;
				** g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
				*/
	    		setRenderingHint.invoke(g, new Object[] { keyAA, valueAA });
	    		
	    		/*
				** g2d.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
				*/
	    		setRenderingHint.invoke(g, new Object[] { keyRender, valueRender });
			}
			catch (Exception ex) {}
		}
	}
		
	public static void checkRenderSupport()
	{
		try
		{
			Class hintsClass = Class.forName("java.awt.RenderingHints");
			Class hintsKeyClass = Class.forName("java.awt.RenderingHints$Key");
			NewGraphics2D.keyAA = hintsClass.getField("KEY_TEXT_ANTIALIASING").get(null);

			try
			{
				/* RenderingHints.VALUE_TEXT_ANTIALIAS_DEFAULT could be useless on older platforms
				**
				** Preferrably LCD screens, but this is only supported since Java 1.6
				*/
				NewGraphics2D.valueAA = hintsClass.getField("VALUE_TEXT_ANTIALIAS_LCD_HRGB").get(null);
			}
			catch (Exception ex)
			{
				// Supported on older Sun VM's 
				NewGraphics2D.valueAA = hintsClass.getField("VALUE_TEXT_ANTIALIAS_ON").get(null);
			}
	
			NewGraphics2D.keyRender = hintsClass.getField("KEY_RENDERING").get(null);
			NewGraphics2D.valueRender = hintsClass.getField("VALUE_RENDER_QUALITY").get(null);
	
			NewGraphics2D.setRenderingHint = Class.forName("java.awt.Graphics2D").getMethod("setRenderingHint", new Class[] { hintsKeyClass, Object.class });

			if (NewGraphics2D.setRenderingHint != null)
				NewGraphics2D.hasRenderingHints = true;
		}
		catch (Exception ex) { System.out.println("No anti-alias render support found."); }
	}
}
